# crds-catalog

[![Build Status](https://ci.rknet.org/api/badges/infra/crds-catalog/status.svg)](https://ci.rknet.org/repos/infra/crds-catalog)
[![License: MIT](https://img.shields.io/badge/License-MIT-blue.svg?label=license)](https://gitea.rknet.org/infra/crds-catalog/src/branch/main/LICENSE)

This repository to aggregatepopular Kubernetes CRDs (CustomResourceDefinition) in JSON schema format. These schemas can be used by various tools such as Datree, Kubeconform and Kubeval to perform validation on custom (and native) Kuberentes resources. Running Kubernetes schema validation checks helps apply the "shift-left approach" on machines without giving them access to your cluster (e.g. locally or on CI).

The project is inspired by [Datree's CRDs-catalog](https://github.com/datreeio/CRDs-catalog) and was created to manage CRDs required for my own Kubernetes deployments.

## Usage

Schemes are generated by the CI and automatically pushed to the `catalog` branch.

### Kubeconform

```Shell
kubeconform \
    -schema-location default \
    -schema-location 'https://gitea.rknet.org/infra/crds-catalog/raw/branch/catalog/{{.Group}}/{{.ResourceKind}}_{{.ResourceAPIVersion}}.json' \
    <path/to/manifest.yaml>
```

## License

This project is licensed under the MIT License - see the [LICENSE](https://github.com/ansible/galaxy/blob/main/LICENSE) file for details.
